###################################################################################################
##########                               EXERCISE: PYTEST                                ##########
###################################################################################################
# Step 1: Install pytest in Thonny
# Step 2: Make sure you can run this file to confirm your pytest installation.
#         NOTE: at this stage, you should see "3 failed, 1 passed"
# Step 3: Update the assertion in test_is_palindrome_base_1 to check the second base case
# Step 4: Update the assertion in test_is_palindrome_recursive_true to check the recursive case
#         when True should be returned
# Step 5: Update the assertion in test_is_palindrome_recursive_false to check the recursive case
#         when False should be returned
# ...
# STOP AND CHECK: at this point, you should have only a green message saying "4 passed"
#                 if you don't, check on the test that is failing
# ...
# Step 6: Make changes to is_palindrome so that all of the tests fail 
#         NOTE: you might want to copy a clean version of the function first!
###################################################################################################
# If you have extra time, start working on problems from one of the CS 150 practice exams!
###################################################################################################


def is_palindrome(s):
    """
    Checks if a string is a palindrome

    Args:
        s (string): the string to test

    Returns:
        bool: whether or not s is a palindrome
    """
    if len(s) == 0 or len(s) == 1:
        return True
    elif s[0] == s[-1]:
        return is_palindrome(s[1:-1])
    else:
        return False


def test_is_palindrome_base_0():
    """
    Test the first base case: s is an empty string
    """
    assert is_palindrome("") # the same as: assert is_palindrome("") == True


def test_is_palindrome_base_1():
    """
    Test the second base case: s is a string with 1 character
    """
    assert False


def test_is_palindrome_recursive_true():
    """
    Test the recursive case when the function should return True
    """
    assert False


def test_is_palindrome_recursive_false():
    """
    Test the recursive case when the function should return False
    """
    assert False


##########################################################################################
# Configuration required to use pytest with Thonny (they aren't designed to work together)
# DO NOT CHANGE!!!
from pytest import main
if __name__ == "__main__":
    main([__file__])
##########################################################################################
